/* 4-bit RTL counter with bidirectional bus controlled by load input */

`timescale 1ns/1ns
module counter (d, clock, load, reset);
   inout [3:0] d;
   reg   [3:0] q;
   input clock, load, reset;
   reg [0:0] double;
   
   assign d = load ? 4'bz : q;
   
   always @(posedge clock)
    begin
       if (!reset)    q = 0;
       else if (load) q = d;
       else           q = q + 1;
    end
   
endmodule /* counter */
