/* Testbench for writing VCD file */
/* Counter is bidirectional, with the load signal controling the direction */
`timescale 1ns/1ns
module test;
   reg  [3:0] d_reg;
   wire [3:0] d;
   reg clock, reset, load, stop, strobe;
   parameter CYCLE = 20;
   real      r_big, r_small;
   
   assign d = load ? d_reg : 4'bz;
   
   counter i1 (d, clock, load, reset);

   dummy i2 ();
   
   always 
    begin
       clock = 0;
       #(CYCLE / 2 - 1)
	strobe = 1;
	$display("@%t  d=%b, clock=%b, load=%b, reset=%b",
	         $realtime, d, clock, load, reset);
       #1 clock = 1;
       strobe = 0;
       #(CYCLE / 2) ;
       end

   always @clock
     begin
	r_big = r_big*1010;
	r_small = r_small/3;
     end
   
   initial
    begin
       $dumpvars(2, test);
//       $monitor("@%0d  d=%b, clock=%b, load=%b, reset=%b",
//	         $stime, d, clock, load, reset);
       $timeformat(-9, 0, "ns", 5);
       r_big = 9999.0;
       r_small = 20.0;
       d_reg = 0;
       stop = 0;
       strobe = 0;
       load = 0;
       reset = 0;
       #15
	reset = 1;
       #20 d_reg = 4;
       #20 load = 1;
       #20 load = 0;
       #350 stop = 1;
       $finish;
    end
endmodule /* test */
   
module dummy;
   reg r;
   initial
    #30 r = 1;
endmodule /* dummy */
   
